--Author: Venkata Potluri
--Date: April 04, 2015

DECLARE
   TYPE T_ID IS TABLE OF SIEBEL.S_LOY_NOTE_TXN.ROW_ID%TYPE;

   ARR_ID       T_ID;
   LOG_ROW_ID   NUMBER := 0;
   ROW_COUNT    NUMBER := 0;

   CURSOR C1
   IS
      SELECT B.ROW_ID
        FROM SIEBEL.S_LOY_NOTE_TXN B
             INNER JOIN SIEBEL_PURGE.TEMP_TXN_XPF A
                ON A.TXN_ID = B.SRC_ROW_ID
       WHERE B.X_PURGE_FLG IS NULL;
BEGIN
   SELECT CASE WHEN MAX (ROW_ID) IS NOT NULL THEN MAX (ROW_ID) + 1 ELSE 1 END
     INTO LOG_ROW_ID
     FROM SIEBEL_PURGE.PURGE_LOG;

   INSERT INTO SIEBEL_PURGE.PURGE_LOG (ROW_ID, PROCESS_NAME, START_TIME)
      SELECT LOG_ROW_ID, 'Update S_LOY_NOTE_TXN XPF', SYSDATE
        FROM DUAL;

   COMMIT;

   OPEN C1;

   LOOP
      --FETCH C1 BULK COLLECT INTO ARR_ID LIMIT 10000;
	  FETCH C1 BULK COLLECT INTO ARR_ID LIMIT 50;

      FORALL ROW IN ARR_ID.FIRST .. ARR_ID.LAST
         UPDATE SIEBEL.S_LOY_NOTE_TXN
            SET X_PURGE_FLG = 'Y'
          WHERE ROW_ID = ARR_ID (ROW);

      ROW_COUNT := ROW_COUNT + SQL%ROWCOUNT;

      UPDATE SIEBEL_PURGE.PURGE_LOG
         SET PROCESSED_ROWS = ROW_COUNT
       WHERE ROW_ID = LOG_ROW_ID;

      COMMIT;

      EXIT WHEN C1%NOTFOUND;
   END LOOP;

   CLOSE C1;

   UPDATE SIEBEL_PURGE.PURGE_LOG
      SET END_TIME = SYSDATE, PROCESSED_ROWS = ROW_COUNT
    WHERE ROW_ID = LOG_ROW_ID;

   COMMIT;
END;
/

QUIT