--Author: Venkata Potluri
--Date: April 08, 2015

DECLARE
   TYPE T_ID IS TABLE OF SIEBEL_PURGE.P_INT_S_CONTACT_XM.PMT_ID%TYPE;

   ARR_ID    T_ID;
   LOG_ROW_ID   NUMBER := 0;
   ROW_COUNT    NUMBER := 0;

   CURSOR C1
   IS
      SELECT PMT_ID
        FROM SIEBEL_PURGE.P_INT_S_CONTACT_XM;
BEGIN
   SELECT CASE WHEN MAX (ROW_ID) IS NOT NULL THEN MAX (ROW_ID) + 1 ELSE 1 END
     INTO LOG_ROW_ID
     FROM SIEBEL_PURGE.PURGE_LOG;

   INSERT INTO SIEBEL_PURGE.PURGE_LOG (ROW_ID, PROCESS_NAME, START_TIME)
      SELECT LOG_ROW_ID, 'Update S_CONTACT_XM', SYSDATE
        FROM DUAL;

   COMMIT;

   OPEN C1;

   LOOP
      FETCH C1 BULK COLLECT INTO ARR_ID LIMIT 1000;
	  --FETCH C1 BULK COLLECT INTO ARR_ID LIMIT 50;

      FORALL ROW IN ARR_ID.FIRST .. ARR_ID.LAST
         UPDATE SIEBEL.S_CONTACT_XM
            SET X_SP_MEMBER_NUM = NULL
          WHERE ROW_ID = ARR_ID (ROW);

      ROW_COUNT := ROW_COUNT + SQL%ROWCOUNT;

      UPDATE SIEBEL_PURGE.PURGE_LOG
         SET PROCESSED_ROWS = ROW_COUNT
       WHERE ROW_ID = LOG_ROW_ID;

      COMMIT;

      EXIT WHEN C1%NOTFOUND;
   END LOOP;

   CLOSE C1;

   UPDATE SIEBEL_PURGE.PURGE_LOG
      SET END_TIME = SYSDATE, PROCESSED_ROWS = ROW_COUNT
    WHERE ROW_ID = LOG_ROW_ID;

   COMMIT;
END;
/

QUIT